## ros-one-controller-interface 0.20.0-1jammy.20251023.0026

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(controller_interface)

# Load catkin and all dependencies required for this package
find_package(catkin REQUIRED COMPONENTS
  hardware_interface
  roscpp
)

# Declare a catkin package
catkin_package(
  INCLUDE_DIRS
    include
  CATKIN_DEPENDS
    hardware_interface
    roscpp
)


###########
## Build ##
###########

# Specify header include paths
include_directories(include ${catkin_INCLUDE_DIRS})


#############
## Testing ##
#############

if(CATKIN_ENABLE_TESTING)
  catkin_add_gmock(controller_base_test test/controller_base_test.cpp)
  target_link_libraries(controller_base_test ${catkin_LIBRARIES})
endif()


#############
## Install ##
#############

# Install headers
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

=== debian/changelog ===
ros-one-controller-interface (0.20.0-1jammy.20251023.0026) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 23 Oct 2025 00:26:05 +0000

ros-one-controller-interface (0.20.0-0jammy) jammy; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 27 Oct 2023 00:00:00 -0000

ros-one-controller-interface (0.19.6-0jammy) jammy; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 21 Oct 2022 00:00:00 -0000

ros-one-controller-interface (0.19.5-0jammy) jammy; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 16 Jun 2021 00:00:00 -0000

ros-one-controller-interface (0.19.4-0jammy) jammy; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 05 Dec 2020 00:00:00 -0000

ros-one-controller-interface (0.19.3-0jammy) jammy; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 11 Oct 2020 00:00:00 -0000

ros-one-controller-interface (0.19.2-0jammy) jammy; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 17 Aug 2020 00:00:00 -0000

ros-one-controller-interface (0.19.1-0jammy) jammy; urgency=high

  * Function specifiers noetic (#453 <https://github.com/ros-controls/ros_control/issues/453>)
    * Add override specifiers & default constructors
    * Delete ControllerBase copy & move ctors
    * Remove unnecessary default constructors
    * Modernize additional constructors
    * Revert ImuSensorHandle::Data::Data() = default
    * Remove unnecessary default overridden constructors
    * Remove semicolon after function body
    Co-authored-by: Matt Reynolds <mtreynolds@uwaterloo.ca>
  * Use setuptools instead of distutils (#429 <https://github.com/ros-controls/ros_control/issues/429>)
  * Contributors: Bence Magyar, Matt Reynolds

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 10 May 2020 00:00:00 -0000

ros-one-controller-interface (0.19.0-0jammy) jammy; urgency=high

  * Replace enums with enum classes (#412 <https://github.com/ros-controls/ros_control/issues/412>)
  * Contributors: Matt Reynolds

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 23 Apr 2020 00:00:00 -0000

ros-one-controller-interface (0.18.0-0jammy) jammy; urgency=high

  * Bump CMake version to avoid CMP0048 (#427 <https://github.com/ros-controls/ros_control/issues/427>)
  * Contributors: Shane Loretz

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 16 Apr 2020 00:00:00 -0000

ros-one-controller-interface (0.17.0-0jammy) jammy; urgency=high

  * Use default member initializers
  * Prefer default member initializers
  * Contributors: Bence Magyar, Matt Reynolds

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 24 Feb 2020 00:00:00 -0000

ros-one-controller-interface (0.16.0-0jammy) jammy; urgency=high

  * Update dependencies
    - Dependencies needed to compile are <build_depend>
    - Dependencies used in public headers are <build_export_depend>
    - Dependencies needed to link or run are <exec_depend>
  * Replace header guard with #pragma once
  * Remove unnecessary  rosunit/rostest dependencies
  * Apply consistent style to CMakeLists.txt files
  * Apply consistent style to package.xml files
  * Multi-update cycle mode switch (#391 <https://github.com/ros-controls/ros_control/issues/391>)
    For more info: https://github.com/pal-robotics-forks/ros_control2/pull/5
    * Added tests for ControllerManager update
    * Mocks for controllers and controller loader in update test
    * Divided in tests with and without controllers
    * Controller state initialized in mock
    * Moved mocks to test class
    * All tests using mock class
    * Test for multiple updates in a single controller
    * Added new switchResult() function to RobotHW interface
    ControllerManager uses this function to wait for the result of the
    doSwitch() before starting the new set of controllers
    * Using ranged based loops
    * Switch is now managed in a separate function
    * Option to start controllers as soon as their joints are ready after a switch
    * Tests for controller_interface API
    * Added new STOPPED, WAITING and ABORTED states to ControllerBase
    * Split manageSwitch() into smaller functions
    * Abort pending controllers in case of switch error
    * Changed default behaviour of new switch param
    This way if it not set it will be the same behaviour as previous version
    * Added timeout parameter to switch controller
    * Removed unnecessary includes
    * Using target_include_directories for the test
    * std::all_of instead of std::count_if
    * Deleted autogenerated file
    * Adapted tests to changes in controller_manager
    * Adapted python implementation to new parameters in SwitchController
    * Added missing parameter description docstring
    * Moved all parameters used for switching to a separate object
    * Moved error messages to controller_base
    * State check functions are now const
    * Removed unnecessary comments
    * Added constants for start_asap and timeout default parameters values
  * Removed unnecessary comments
  * State check functions are now const
  * Moved error messages to controller_base
  * Using target_include_directories for the test
  * Fixed lincenses
  * Removed unnecessary includes
  * Abort pending controllers in case of switch error
  * Added new STOPPED, WAITING and ABORTED states to ControllerBase
  * Tests for controller_interface API
  * Contributors: Bence Magyar, Jordan Palacios, Matt Reynolds, jordan-palacios

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 27 Jan 2020 00:00:00 -0000

ros-one-controller-interface (0.15.1-0jammy) jammy; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 30 Sep 2018 00:00:00 -0000

ros-one-controller-interface (0.15.0-0jammy) jammy; urgency=high

  * boost::shared_ptr -> std::shared_ptr
  * Introduce shared_ptr typedefs


## ros-one-controller-interface 0.20.0-1jammy.20260220.2124

=== debian/changelog ===
ros-one-controller-interface (0.20.0-1jammy.20260220.2124) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 20 Feb 2026 21:24:44 +0000

## ros-one-controller-interface 0.20.0-1noble.20251023.0024

=== debian/changelog ===
ros-one-controller-interface (0.20.0-1noble.20251023.0024) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 23 Oct 2025 00:24:46 +0000

ros-one-controller-interface (0.20.0-0noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 27 Oct 2023 00:00:00 -0000

ros-one-controller-interface (0.19.6-0noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 21 Oct 2022 00:00:00 -0000

ros-one-controller-interface (0.19.5-0noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Wed, 16 Jun 2021 00:00:00 -0000

ros-one-controller-interface (0.19.4-0noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sat, 05 Dec 2020 00:00:00 -0000

ros-one-controller-interface (0.19.3-0noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 11 Oct 2020 00:00:00 -0000

ros-one-controller-interface (0.19.2-0noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 17 Aug 2020 00:00:00 -0000

ros-one-controller-interface (0.19.1-0noble) noble; urgency=high

  * Function specifiers noetic (#453 <https://github.com/ros-controls/ros_control/issues/453>)
    * Add override specifiers & default constructors
    * Delete ControllerBase copy & move ctors
    * Remove unnecessary default constructors
    * Modernize additional constructors
    * Revert ImuSensorHandle::Data::Data() = default
    * Remove unnecessary default overridden constructors
    * Remove semicolon after function body
    Co-authored-by: Matt Reynolds <mtreynolds@uwaterloo.ca>
  * Use setuptools instead of distutils (#429 <https://github.com/ros-controls/ros_control/issues/429>)
  * Contributors: Bence Magyar, Matt Reynolds

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 10 May 2020 00:00:00 -0000

ros-one-controller-interface (0.19.0-0noble) noble; urgency=high

  * Replace enums with enum classes (#412 <https://github.com/ros-controls/ros_control/issues/412>)
  * Contributors: Matt Reynolds

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 23 Apr 2020 00:00:00 -0000

ros-one-controller-interface (0.18.0-0noble) noble; urgency=high

  * Bump CMake version to avoid CMP0048 (#427 <https://github.com/ros-controls/ros_control/issues/427>)
  * Contributors: Shane Loretz

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Thu, 16 Apr 2020 00:00:00 -0000

ros-one-controller-interface (0.17.0-0noble) noble; urgency=high

  * Use default member initializers
  * Prefer default member initializers
  * Contributors: Bence Magyar, Matt Reynolds

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 24 Feb 2020 00:00:00 -0000

ros-one-controller-interface (0.16.0-0noble) noble; urgency=high

  * Update dependencies
    - Dependencies needed to compile are <build_depend>
    - Dependencies used in public headers are <build_export_depend>
    - Dependencies needed to link or run are <exec_depend>
  * Replace header guard with #pragma once
  * Remove unnecessary  rosunit/rostest dependencies
  * Apply consistent style to CMakeLists.txt files
  * Apply consistent style to package.xml files
  * Multi-update cycle mode switch (#391 <https://github.com/ros-controls/ros_control/issues/391>)
    For more info: https://github.com/pal-robotics-forks/ros_control2/pull/5
    * Added tests for ControllerManager update
    * Mocks for controllers and controller loader in update test
    * Divided in tests with and without controllers
    * Controller state initialized in mock
    * Moved mocks to test class
    * All tests using mock class
    * Test for multiple updates in a single controller
    * Added new switchResult() function to RobotHW interface
    ControllerManager uses this function to wait for the result of the
    doSwitch() before starting the new set of controllers
    * Using ranged based loops
    * Switch is now managed in a separate function
    * Option to start controllers as soon as their joints are ready after a switch
    * Tests for controller_interface API
    * Added new STOPPED, WAITING and ABORTED states to ControllerBase
    * Split manageSwitch() into smaller functions
    * Abort pending controllers in case of switch error
    * Changed default behaviour of new switch param
    This way if it not set it will be the same behaviour as previous version
    * Added timeout parameter to switch controller
    * Removed unnecessary includes
    * Using target_include_directories for the test
    * std::all_of instead of std::count_if
    * Deleted autogenerated file
    * Adapted tests to changes in controller_manager
    * Adapted python implementation to new parameters in SwitchController
    * Added missing parameter description docstring
    * Moved all parameters used for switching to a separate object
    * Moved error messages to controller_base
    * State check functions are now const
    * Removed unnecessary comments
    * Added constants for start_asap and timeout default parameters values
  * Removed unnecessary comments
  * State check functions are now const
  * Moved error messages to controller_base
  * Using target_include_directories for the test
  * Fixed lincenses
  * Removed unnecessary includes
  * Abort pending controllers in case of switch error
  * Added new STOPPED, WAITING and ABORTED states to ControllerBase
  * Tests for controller_interface API
  * Contributors: Bence Magyar, Jordan Palacios, Matt Reynolds, jordan-palacios

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Mon, 27 Jan 2020 00:00:00 -0000

ros-one-controller-interface (0.15.1-0noble) noble; urgency=high



 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Sun, 30 Sep 2018 00:00:00 -0000

ros-one-controller-interface (0.15.0-0noble) noble; urgency=high

  * boost::shared_ptr -> std::shared_ptr
  * Introduce shared_ptr typedefs


=== debian/control ===
Source: ros-one-controller-interface
Section: misc
Priority: optional
Maintainer: Bence Magyar <bence.magyar.robotics@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-one-catkin, ros-one-hardware-interface, ros-one-roscpp
Homepage: https://github.com/ros-controls/ros_control/wiki
Standards-Version: 3.9.2

Package: ros-one-controller-interface
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-one-hardware-interface, ros-one-roscpp
Description: Interface base class for controllers.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-controller-interface//opt/ros/one/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install

## ros-one-controller-interface 0.20.0-1noble.20260220.2131

=== debian/changelog ===
ros-one-controller-interface (0.20.0-1noble.20260220.2131) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Bence Magyar <bence.magyar.robotics@gmail.com>  Fri, 20 Feb 2026 21:31:44 +0000
